local M = {}

--Save File: {1,2,3,4,5,6,7,8,9,10,11,12,13,14,15} - Theme 1-3
--           {16, 17, 18, 19} - Trophy Curling, Cue, Target, Airborne
--			 {1} - Darts
--           {15} - Singularity
--           {20, 21, 22, 23, 24} - Theme 4

local function updateTrophies(digit, rangeLow, diamondCount, achieved)
	if diamondCount == 20 then
		local emptyPos, trophyPos = "100000 0 0", "-1163.69 -1590.78 3"
		if not achieved then emptyPos, trophyPos = trophyPos, emptyPos end
		
		TorqueScript.eval([[
			trophy_diamond_empty.position = "]]..emptyPos..[[";
			trophy_diamond.position = "]]..trophyPos..[[";
		]])
	end
	if digit == nil then
		--Forest
		if rangeLow == 1 then 
			local emptyPos, trophyPos = "100000 0 0", "-695.911987 -1260.14001 3"
			if not achieved then emptyPos, trophyPos = trophyPos, emptyPos end
			
			TorqueScript.eval([[
				trophy_forest_empty.position = "]]..emptyPos..[[";
				trophy_forest.position = "]]..trophyPos..[[";
			]])
		--Tech
		elseif rangeLow == 6 then 
			local emptyPos, trophyPos = "100000 0 0", "-695.911987 -1330.14001 3"
			if not achieved then emptyPos, trophyPos = trophyPos, emptyPos end
			
			TorqueScript.eval([[
				trophy_tech_empty.position = "]]..emptyPos..[[";
				trophy_tech.position = "]]..trophyPos..[[";
			]])
		--Space
		elseif rangeLow == 11 then 
			local emptyPos, trophyPos = "100000 0 0", "-695.911987 -1400.14001 3"
			if not achieved then emptyPos, trophyPos = trophyPos, emptyPos end
			
			TorqueScript.eval([[
				trophy_space_empty.position = "]]..emptyPos..[[";
				trophy_space.position = "]]..trophyPos..[[";
			]])
		--Planets
		elseif rangeLow == 20 then 
			local emptyPos, trophyPos = "100000 0 0", "-695.911987 -1470.14001 3"
			if not achieved then emptyPos, trophyPos = trophyPos, emptyPos end
			
			TorqueScript.eval([[
				trophy_planets_empty.position = "]]..emptyPos..[[";
				trophy_planets.position = "]]..trophyPos..[[";
			]])
		end
	else
		--Darts
		if digit == 1 then
			local emptyPos, trophyPos = "100000 0 0", "-735.906982 -1641.93994 3"
			if not achieved then emptyPos, trophyPos = trophyPos, emptyPos end
			
			TorqueScript.eval([[
				trophy_darts_empty.position = "]]..emptyPos..[[";
				trophy_darts.position = "]]..trophyPos..[[";
			]])
		--Curling
		elseif digit == 16 then
			local emptyPos, trophyPos = "100000 0 0", "-805.906982 -1641.93994 3"
			if not achieved then emptyPos, trophyPos = trophyPos, emptyPos end
			
			TorqueScript.eval([[
				trophy_curling_empty.position = "]]..emptyPos..[[";
				trophy_curling.position = "]]..trophyPos..[[";
			]])
		--Cuegames
		elseif digit == 17 then 
			local emptyPos, trophyPos = "100000 0 0", "-875.906982 -1641.93994 3"
			if not achieved then emptyPos, trophyPos = trophyPos, emptyPos end
			
			TorqueScript.eval([[
				trophy_snooker_empty.position = "]]..emptyPos..[[";
				trophy_snooker.position = "]]..trophyPos..[[";
			]])
		--Targets
		elseif digit == 18 then 
			local emptyPos, trophyPos = "100000 0 0", "-945.906982 -1641.93994 3"
			if not achieved then emptyPos, trophyPos = trophyPos, emptyPos end
			
			TorqueScript.eval([[
				trophy_targets_empty.position = "]]..emptyPos..[[";
				trophy_targets.position = "]]..trophyPos..[[";
			]])
		--Airborne
		elseif digit == 19 then 
			local emptyPos, trophyPos = "100000 0 0", "-1015.90997 -1641.93994 3"
			if not achieved then emptyPos, trophyPos = trophyPos, emptyPos end
			
			TorqueScript.eval([[
				trophy_airborne_empty.position = "]]..emptyPos..[[";
				trophy_airborne.position = "]]..trophyPos..[[";
			]])
			
		--Singularity
		elseif digit == 15 then 
			local emptyPos, trophyPos = "100000 0 0", "-1163.09 -1519.9 3";
			if not achieved then emptyPos, trophyPos = trophyPos, emptyPos end
			
			TorqueScript.eval([[
				trophy_singularity_empty.position = "]]..emptyPos..[[";
				trophy_singularity.position = "]]..trophyPos..[[";
			]])
		end
	end
end

local function checkDiamond(index, number)
 	if number >= 5 then return 1
	else return 0
	end
end

local function fileCheck_trophy(rangeL, rangeU, digit, requirement)
	local file = io.open("cargames_save.txt", "r")
	local medals = file:read()
	file:close()
	
	local update = true
	--loop through save 'number'
	for i = 1, #medals do
		local number = tonumber(medals:sub(i,i))
		
		if (rangeL ~= nil and rangeU ~= nil) and (i >= rangeL and i <= rangeU) then --Check range of digit in 'number'
			--Do NOT Update THEME trophy if not >= bronze medal
			if number == 0 then 
				update = false
				break 
			end
		end
		
		if (digit ~= nil and requirement ~= nil) and i == digit then --Check range of digit in 'number'
			--Do NOT Update EVENT trophy if not correct value in 'number'
			if number ~= requirement then update = false end
			break
		end
	end
	
	updateTrophies(digit, rangeL, nil, update)
end

local function getMedal(num)
	if     num == 1             then return 'bronze'
	elseif num == 2             then return 'silver'
	elseif num == 3             then return 'gold'
	elseif num == 4             then return 'platinum'
	elseif num == 5 or num == 6 then return 'diamond'
	else return 'none'
	end
end

local function fileCheck_medal()
	local file = io.open("cargames_save.txt", "r")
	local medals = file:read()
	file:close()
	
	local diamond = 0
	
	for i = 1, 24 do --24 being event limit (currently)
		local number = tonumber(medals:sub(i,i))
		local xCoord, zCoord = 0, 12.8029
		if     i <= 5  then xCoord = -1138.48+(28*(i-1 ))
		elseif i <= 10 then xCoord = -988.462+(28*(i-6 ))
		elseif i <= 15 then xCoord = -838.487+(28*(i-11)) 
		elseif i <= 19 then goto continue
		elseif i <= 24 then 
			xCoord = -1138.48+(28*(i-1-19))
			zCoord = 41.29774+12.8029
		end
		
		diamond = diamond + checkDiamond(i, number)
		local numberAsMedal = getMedal(number) --Gets medal from number

		if numberAsMedal == 'none' then --If no medal achieved then reset all of those medals as a safe-guard
			TorqueScript.eval([[
				]]..getMedal(1)..[[]]..i..[[.position = "10000 0 0";
				]]..getMedal(2)..[[]]..i..[[.position = "10000 0 0";
				]]..getMedal(3)..[[]]..i..[[.position = "10000 0 0";
				]]..getMedal(4)..[[]]..i..[[.position = "10000 0 0";
				]]..getMedal(5)..[[]]..i..[[.position = "10000 0 0";
			]])
		else TorqueScript.eval(numberAsMedal..''..i..'.position = "'..xCoord..' -1236.83997 '..zCoord..'";')
		end
		
		::continue:: --Workaround with Lua not having a continue keyword command
	end
	
	if diamond == 20 then updateTrophies(nil, nil, diamond) end
end

local function checkTrophies()
	--Theme Trophies
	fileCheck_trophy(1 ,  5, nil, nil) --Theme 1
	fileCheck_trophy(6 , 10, nil, nil) --Theme 2
	fileCheck_trophy(11, 15, nil, nil) --Theme 3
	fileCheck_trophy(20, 24, nil, nil) --Theme 4
	
	--Event Trophies
	fileCheck_trophy(nil, nil, 1 , 6) --Darts
	fileCheck_trophy(nil, nil, 16, 1) --Curling
	fileCheck_trophy(nil, nil, 17, 1) --CueGames
	fileCheck_trophy(nil, nil, 18, 1) --Targets
	fileCheck_trophy(nil, nil, 19, 1) --Airborne
	
	--Misc
	fileCheck_trophy(nil, nil, 15, 6) --Singularity
end

local function checkMedals()
	--Checks all medals
	fileCheck_medal()
end

local function onScenarioChange(scenario)
	if scenario.state == 'pre-running' then
		local file = io.open("cargames_save.txt", "r")
		if file == nil then 
			file = io.open("cargames_save.txt", "w")
			file:write('000000000000000000000000') --Setup save data
		end
		
		checkTrophies()
		checkMedals()
		
		TorqueScript.eval([[
			player.position = "-932.465454 -1358.62671 0.125208631";
			platform_2.position = "10000 0 0";
			teleporter_2.position = "10000 0 0";
		]])
		be:reloadStaticCollision();
	end
end

local function onBeamNGTrigger(data)
	if string.find(data.triggerName, 'portal') and data.event == 'enter' then
		if data.triggerName == 'portal_p1' then 
			TorqueScript.eval([[
				player.position = "-932.465454 -1358.62671 0.125208631";
				platform_2.position = "10000 0 0";
				teleporter_2.position = "10000 0 0";
			]])
			be:reloadStaticCollision();
		elseif data.triggerName == 'portal_p2' then 
			TorqueScript.eval([[
				player.position = "-932.465454 -1358.62671 43";
				platform_2.position = "-706.588013 -1540.26001 39.4744987";
				teleporter_2.position = "-944.935852 -1540.86243 84.394104";
			]])
			be:reloadStaticCollision();
		end
	end
end

M.onBeamNGTrigger = onBeamNGTrigger
M.onScenarioChange = onScenarioChange
return M